#ifndef _CLM_H_
#define _CLM_H_

typedef struct {
	float *values;
	unsigned int rows;
	unsigned int cols;
} clm_Matrix;

typedef struct {
	float *values;
	int length;
} clm_Vector;

clm_Vector clm_createVector(int length);
void clm_freeVector(clm_Vector vector);

typedef struct {
	clm_Matrix weights, bias;
} clm_Layer;

typedef struct {
	clm_Layer *layers;
	unsigned int numLayers;
} clm_NN;

clm_NN clm_createNN(unsigned int numLayers, unsigned int *layerSizes);

clm_Matrix clm_createMatrixRandom(unsigned int rows, unsigned int cols);
clm_Matrix clm_matrixAddScalar(clm_Matrix mat, float scalar);
clm_Matrix clm_matrixAddMatrix(clm_Matrix mat, clm_Matrix other);
clm_Matrix clm_matrixSubtractMatrix(clm_Matrix mat, clm_Matrix other);
clm_Matrix clm_matrixTranspose(clm_Matrix mat);
clm_Matrix clm_matrixMultiplyMatrix(clm_Matrix a, clm_Matrix b);
clm_Matrix clm_matrixMultiplyScalar(clm_Matrix mat, float scalar);

void clm_matrixPrint(clm_Matrix mat);

#endif
